// --------------------------------------------------------
// Copyright (c)
//
// contributions by Ansgar
//                  ansgar.radermacher@cea.fr
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#include "addClientCompdef/AddClient_impl.h"

using namespace std::chrono_literals;
// declare options
rclcpp::NodeOptions addclient_options;

int main(int argc, char **argv) {
  rclcpp::init(argc, argv);

  auto addclient = std::make_shared < addClientCompdef::AddClient_impl
      > (addclient_options);

  RCLCPP_INFO(addclient->get_logger(), "AddClient has been initialized");

  addclient->register_on_activate([&addclient](const rclcpp_lifecycle::State&) {
    addclient->fOnActivate();
    // periodic execution (1s) for CallAdd using a wall timer
    // create a callback group for the timer
    addclient->timer_CallAdd_ = addclient->create_wall_timer(1s, std::bind(&addClientCompdef::AddClient_impl::fPeriodic, addclient), addclient->cbg_t_CallAdd_);
    return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
  }
  );
  addclient->register_on_deactivate(
      [&addclient](const rclcpp_lifecycle::State&) {
        // stop timer of CallAdd
        addclient->timer_CallAdd_->cancel();
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );
  addclient->register_on_shutdown(
      [&addclient](const rclcpp_lifecycle::State&) {
        // stop timer of CallAdd
        addclient->timer_CallAdd_->cancel();
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );

  rclcpp::executors::MultiThreadedExecutor executor;

  executor.add_node(addclient->get_node_base_interface());

  executor.spin();
  rclcpp::shutdown();
}

